abuild-sign.in 2.07 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# abuild-sign - sign indexes
Natanael Copa's avatar
Natanael Copa committed
4 5 6 7 8 9
# Copyright (c) 2009 Natanael Copa <ncopa@alpinelinux.org>
#
# Distributed under GPL-2
#

abuild_ver=@VERSION@
10
datadir=@datadir@
Natanael Copa's avatar
Natanael Copa committed
11

12 13
if ! [ -f "$datadir/functions.sh" ]; then
	echo "$datadir/functions.sh: not found" >&2
Natanael Copa's avatar
Natanael Copa committed
14
	exit 1
15 16
fi
. "$datadir/functions.sh"
Natanael Copa's avatar
Natanael Copa committed
17

Dubiousjim's avatar
Dubiousjim committed
18
do_sign() {
Dubiousjim's avatar
Dubiousjim committed
19 20
	local f i keyname repo

Dubiousjim's avatar
Dubiousjim committed
21 22 23 24 25 26 27
	# we are actually only interested in the name, not the file itself
	keyname=${pubkey##*/}

	for f; do
		i=$(readlink -f $f)
		[ -d "$i" ] && i="$i/APKINDEX.tar.gz"
		repo="${i%/*}"
28 29 30
		(
		set -e
		cd "$repo"
Dubiousjim's avatar
Dubiousjim committed
31
		sig=".SIGN.RSA.$keyname"
32
		openssl dgst -sha1 -sign "$privkey" -out "$sig" "$i"
Dubiousjim's avatar
Dubiousjim committed
33 34 35 36 37
		tmptargz=$(mktemp)
		tar -c "$sig" | abuild-tar --cut | gzip -9 > "$tmptargz"
		tmpsigned=$(mktemp)
		cat "$tmptargz" "$i" > "$tmpsigned"
		rm -f "$tmptargz" "$sig"
Dubiousjim's avatar
Dubiousjim committed
38
		chmod 644 "$tmpsigned"
Dubiousjim's avatar
Dubiousjim committed
39
		mv "$tmpsigned" "$i"
40 41
		msg "Signed $i"
		) || die "failed to sign $i"
Dubiousjim's avatar
Dubiousjim committed
42 43 44
	done
}

Natanael Copa's avatar
Natanael Copa committed
45
usage() {
46
	cat >&2 <<__EOF__
47 48
$program $abuild_ver - sign indexes
Usage: $program [-k PRIVKEY] [-p PUBKEY] INDEXFILE...
49 50 51 52 53 54 55
Options:
  -k, --private KEY  The private key to use for signing
  -p, --public KEY   The name of public key. apk add will look for /etc/apk/keys/KEY
  -q, --quiet
  -h, --help         Show this help

__EOF__
Natanael Copa's avatar
Natanael Copa committed
56 57 58
}

privkey="$PACKAGER_PRIVKEY"
59 60
pubkey=
quiet=
Natanael Copa's avatar
Natanael Copa committed
61

62
args=`getopt -o k:p:qh --long private:,public:,quiet,help -n "$program" -- "$@"`
63 64 65 66 67 68 69 70 71 72 73 74 75
if [ $? -ne 0 ]; then
	usage
	exit 2
fi
eval set -- "$args"
while true; do
	case $1 in
		-k|--private) privkey=$2; shift;;
		-p|--public) pubkey=$2; shift;;
		-q|--quiet) quiet=1;; # suppresses msg
		-h|--help) usage; exit;;
		--) shift; break;;
		*) exit 1;; # getopt error
Natanael Copa's avatar
Natanael Copa committed
76
	esac
77
	shift
Natanael Copa's avatar
Natanael Copa committed
78
done
79 80 81 82
if [ $# -eq 0 ]; then
	usage
	exit 2
fi
Natanael Copa's avatar
Natanael Copa committed
83 84

if [ -z "$privkey" ]; then
85 86 87
	cat >&2 << __EOF__
No private key found. Use 'abuild-keygen' to generate the keys.
Then you can either:
88
  * set the PACKAGER_PRIVKEY in $ABUILD_USERCONF
89
    ('abuild-keygen -a' does this for you)
90
  * set the PACKAGER_PRIVKEY in $ABUILD_CONF
91
  * specify the key with the -k option to $program
92 93

__EOF__
Natanael Copa's avatar
Natanael Copa committed
94 95 96 97 98 99 100
	exit 1
fi

if [ -z "$pubkey" ]; then
	pubkey=${PACKAGER_PUBKEY:-"${privkey}.pub"}
fi

Dubiousjim's avatar
Dubiousjim committed
101
do_sign "$@"
102
exit 0